## who uses it?
- [fliplog][fliplog]: fluent logging with verbose insight, colors, tables, emoji, filtering, spinners, progress bars, timestamps, capturing, stack traces, tracking, presets, & more...
- [lego-api][lego-api] renders the infinitely nestable permutations of conditionals for [fuse-box][fuse-box] so only what you use is included in the bundled api
- [d-l-l][d-l-l] makes your webpack build faster, in just a few lines, without having to waste time with the tedious manual configuration steps required to use the DLLPlugin
- [webpack-split-plugin][webpack-split-plugin] easily split bundles into multiple pieces with custom specifications
- [bench-chain][bench-chain] benchmark recording - averages & graphs.
- [cli-chain][cli-chain] easy, powerful, interactive, infinitely nestable fluent cli builder.
- [awesome-fluents][awesome-fluents] more awesome fluents/chains
- [funwithflags][funwithflags] parse argument options. minimist in es6.
- [chain-able-find][chain-able-find] globby-compatible api, faster, & fluent.

## [examples](https://github.com/fluents/chain-able/tree/master/examples)
- [playground - super small files using features - adapted from tests](https://aretecode.github.io/chain-able-playground/)
  - data type + schema
  - define
  - encase
  - merging
  - observing
  - LocalStorage
  <!-- - transforming -->
- minis - really mini projects for examples
  - decorators (making a chain that can be used to build decorators that work for all combinations*)
  - SwitchChain - making `switch {}` as a chain for fun
- typescript (for intelisense demo)
- decorators (for es6 transpiling experimenting)
- bundler configs (works by default, but easier the better)
- eventually (todo):
  - Events - will be an eventsource example
  - React & MobX
  - Routing
  - FileSystem stuff on nodejs

[d-l-l]: https://github.com/fliphub/d-l-l
[chain-able-find]: https://github.com/fluents/chain-able-find
[fliplog]: https://github.com/aretecode/fliplog
[lego-api]: https://github.com/fuse-box/lego-api
[cli-chain]: https://github.com/fluents/cli-chain
[script-chain]: https://github.com/fluents/script-chain
[bench-chain]: https://github.com/aretecode/bench-chain
[funwithflags]: https://github.com/aretecode/funwithflags
[awesome-fluents]: https://github.com/fluents/awesome-fluents
[easily-minifiable]: https://gist.github.com/aretecode/9b1765a897554b82da96591372d3c149
[awesome-deops]: https://github.com/aretecode/awesome-deopts
[build]: https://github.com/fluents/chain-able/tree/master/build
[size-over-time]: https://github.com/fluents/chain-able/blob/master/build/size-over-time.txt
[stress-test]: https://github.com/aretecode/stress-test
[rollup]: rollupjs.org
[fuse-box]: https://github.com/fuse-box/fuse-box
[buble]: buble.surge.sh
[typescript]: http://www.typescriptlang.org/play/
